-- CSunitBorrow
-- Author: knightmare
-- DateCreated: 9/28/2012 9:11:01 PM
--------------------------------------------------------------

GameEvents.SetAlly.Add(function(iCSPlayer, iOldAlly, iNewAlly) 
	
	print ("SetAlly called, params: " .. tostring(iCSPlayer) .. ", " .. tostring(iOldAlly) .. ", " .. tostring(iNewAlly)); 

	if (iNewAlly == -1) then
		local pPlayer = Players[iOldAlly];
		for unit in pPlayer:Units()
   		do
			if (unit:IsCombatUnit() and unit:GetOriginalOwner() == iCSPlayer) then
				ChangeOwner(unit, iCSPlayer, -1);
			end
		end
	else
		local pPlayer = Players[iCSPlayer];
		for unit in pPlayer:Units()
   		do
			if (unit:IsCombatUnit()) then
				ChangeOwner(unit, iNewAlly, iCSPlayer);
			end
		end
	end

	if (iNewAlly == -1) then
		if (iOldAlly == Game.GetActivePlayer())	then

			local strPlayerKey = Players[iCSPlayer]:GetCivilizationShortDescriptionKey();
		
			-- Put up dialog box
			local popupInfo = {
				Data1 = 500,
				Type = ButtonPopupTypes.BUTTONPOPUP_TEXT,
				Text = Locale.ConvertTextKey("TXT_KEY_1066_SCENARIO_ALLY_LOST", strPlayerKey);
			}
	
			UI.AddPopup(popupInfo);
		end
	else
		if (iNewAlly == Game.GetActivePlayer())	then

			local strPlayerKey = Players[iCSPlayer]:GetCivilizationShortDescriptionKey();
	
			-- Put up dialog box
			local popupInfo = {
				Data1 = 500,
				Type = ButtonPopupTypes.BUTTONPOPUP_TEXT,
				Text = Locale.ConvertTextKey("TXT_KEY_1066_SCENARIO_ALLY_GAINED", strPlayerKey);
			}
	
			UI.AddPopup(popupInfo);
		end
	end

end);

function ChangeOwner (unit, iNewOwner, iPlayerForName)

	local iX;
	local iY;
	local iUnitType;
	local iUnitDamage;
	local iOldOwner;
	local pNewUnit;
	local player;

	iX = unit:GetX();
	iY = unit:GetY();
	iUnitType = unit:GetUnitType();
	iUnitDamage = unit:GetDamage();
	iOldOwner = unit:GetOwner();
	player = Players[iNewOwner];

	unit:Kill();

	pNewUnit = player:InitUnit(iUnitType, iX, iY);
	pNewUnit:SetDamage(iUnitDamage);
	pNewUnit:SetOriginalOwner(iOldOwner);

	if (iPlayerForName ~= -1) then
		local playerName = Locale.ConvertTextKey(Players[iPlayerForName]:GetCivilizationShortDescriptionKey());
		pNewUnit:SetName(playerName);
	else
		pNewUnit:SetName("");
	end
end


local savedData = Modding.OpenSaveData();
local iValue = savedData.GetValue("TurnsBetweenBonuses");